searchNodes=[{"type":"behaviour","title":"LiveState.Channel","doc":"To build a LiveState application, you'll first want to add a channel that use s this module. use LiveState.Channel , web_module : MyAppWeb , max_version : 100 message_builder optional, defaults to {LiveState.MessageBuilder, ignore_keys: [:__meta__]} . If set, should be a tuple whose first element is a module that defines update_state_message/4 and new_state_message/3 and and second element contains any options. Options are passed as final arg to both functions when invoked. See LiveState.MessageBuilder for details max_version optional, defaults to 1000. This is the maximum version number, after which it will reset to 0 and begin incrementing again. Version numbers are used to detect a patch message arriving out of order. If such a condition is detected by phx-live-state a new copy of state is requested.","ref":"LiveState.Channel.html"},{"type":"callback","title":"LiveState.Channel.authorize/3","doc":"Called from join to authorize the connection. Return {:ok, socket} to authorize or {:error, reason} to deny. Default implementation returns {:ok, socket}","ref":"LiveState.Channel.html#c:authorize/3"},{"type":"callback","title":"LiveState.Channel.handle_event/3","doc":"Receives an event an payload from the client and current state. Return a :reply tuple if you need to send events to the client, otherwise return :noreply . :reply tuples can contain a single LiveState.Event or a list of events as well as the new state.","ref":"LiveState.Channel.html#c:handle_event/3"},{"type":"callback","title":"LiveState.Channel.handle_event/4","doc":"Receive an event name, payload, the current state, and the socket. Use this callback if you need to receive the socket as well as the state. Return a :reply tuple if you need to send events to the client, otherwise return :noreply . :reply tuples can contain a single LiveState.Event or a list of events, as well as the new state and the socket. :noreply tuples must contain the new state and and socket.","ref":"LiveState.Channel.html#c:handle_event/4"},{"type":"callback","title":"LiveState.Channel.handle_message/2","doc":"Receives pubsub message and current state. Returns new state","ref":"LiveState.Channel.html#c:handle_message/2"},{"type":"callback","title":"LiveState.Channel.init/3","doc":"Returns the initial application state. Called just after connection","ref":"LiveState.Channel.html#c:init/3"},{"type":"callback","title":"LiveState.Channel.state_key/0","doc":"The key on assigns to hold application state. Defaults to :state .","ref":"LiveState.Channel.html#c:state_key/0"},{"type":"callback","title":"LiveState.Channel.state_version_key/0","doc":"The key on assigns to hold application state version. Defaults to :version .","ref":"LiveState.Channel.html#c:state_version_key/0"},{"type":"protocol","title":"LiveState.Encoder","doc":"Allows customization of the representation of a given type as the state in a LiveState.Channel . It is called before serialization and json diffing.","ref":"LiveState.Encoder.html"},{"type":"function","title":"LiveState.Encoder.encode/2","doc":"","ref":"LiveState.Encoder.html#encode/2"},{"type":"type","title":"LiveState.Encoder.t/0","doc":"All the types that implement this protocol.","ref":"LiveState.Encoder.html#t:t/0"},{"type":"module","title":"LiveState.Event","doc":"","ref":"LiveState.Event.html"},{"type":"type","title":"LiveState.Event.t/0","doc":"Represents a CustomEvent to be returned from a reply and dispatched on the client. Fields: name: becomes the name of the CustomEvent to be dispatched detail: becomes the detail property (payload) of the CustomEvent. Not that because events will be serialized as JSON, everything here must implement Jason.Encoder","ref":"LiveState.Event.html#t:t/0"},{"type":"module","title":"LiveState.MessageBuilder","doc":"This is the default message builder for LiveState. It will send json_patch messages for state updates. The Elixir terms are compared using the JSONDiff library to create the JSON patch. Because JSONDiff is not aware of any impls of the JSON Encoder protocol, the patch may or may not match the JSON encoding in certain cases. Best effort has been made to handle common cases such ecto schemas and DateTime. To gain further control over this process, you may implement the LiveState.Encoder protocol which will allow you to define a pre-diff representation. For a slower, but potentially more correct approach to the problem, there is a branch containing an alternate json diff implemenation in rust.","ref":"LiveState.MessageBuilder.html"},{"type":"function","title":"LiveState.MessageBuilder.new_state_message/3","doc":"","ref":"LiveState.MessageBuilder.html#new_state_message/3"},{"type":"function","title":"LiveState.MessageBuilder.update_state_message/4","doc":"","ref":"LiveState.MessageBuilder.html#update_state_message/4"},{"type":"module","title":"LiveState.TestHelpers","doc":"","ref":"LiveState.TestHelpers.html"},{"type":"macro","title":"LiveState.TestHelpers.assert_state_change/1","doc":"Asserts that state:change message is received over a channel matching the specified pattern","ref":"LiveState.TestHelpers.html#assert_state_change/1"},{"type":"macro","title":"LiveState.TestHelpers.assert_state_patch/1","doc":"Asserts that state:patch message is received over a channel matching the specified pattern","ref":"LiveState.TestHelpers.html#assert_state_patch/1"},{"type":"function","title":"LiveState.TestHelpers.send_event/3","doc":"Pushes a live state event over the channel","ref":"LiveState.TestHelpers.html#send_event/3"},{"type":"task","title":"Mix.Tasks.LiveState.Gen.Channel","doc":"Generates a Livestate channel. $ mix live_state.gen.channel Todo Accepts the module name for the channel The generated files will contain: For a regular application: a channel in lib/my_app_web/channels a channel test in test/my_app_web/channels","ref":"Mix.Tasks.LiveState.Gen.Channel.html"},{"type":"task","title":"Mix.Tasks.LiveState.Gen.Element","doc":"Generates a Livestate channel. $ mix live_state.gen.channel Todo Accepts the module name for the channel The generated files will contain: For a regular application: a channel in lib/my_app_web/channels a channel test in test/my_app_web/channels","ref":"Mix.Tasks.LiveState.Gen.Element.html"},{"type":"extras","title":"LiveState","doc":"This is the Elixir library for building servers for LiveState applications.","ref":"readme.html"},{"type":"extras","title":"LiveState - What is LiveState?","doc":"The goal of LiveState is to make highly interactive web applications easier to build. Currently, in most such applications, clients send requests and receive responses from and to a server API. This essentially results in two applications, with state being managed in both in an ad hoc way. LiveState uses a different approach. Clients dispatch events, which are sent to the server to be handled, and receive updates from the server any time application state changes. This allows state to have a single source of truth, and greatly reduces client code complexity. It also works equally well for applications where updates to state can occur independently from a user initiated, client side event (think &quot;real time&quot; applications such as chat, etc).","ref":"readme.html#what-is-livestate"},{"type":"extras","title":"LiveState - How is LiveState different from LiveView?","doc":"LiveState shares similar goals to LiveView, but takes a different approach which allows for building different kinds of applications. LiveView allows the user to write all of the application code, both server logic and view presentation logic, in Elixir, and entirely manages the web client side of the application. LiveState event handlers are written in Elixir and are quite similar to LiveView event handlers, but LiveState relies on client code to render state and dispatch events. This trade-off keeps client side code simple, but allows LiveState to be used to build applications that are not as good of a fit for LiveView.","ref":"readme.html#how-is-livestate-different-from-liveview"},{"type":"extras","title":"LiveState - Installation","doc":"This package can be installed by adding live_state to your list of dependencies in mix.exs : def deps do [ { :live_state , &quot;~&gt; 0.8.1&quot; } , { :cors_plug , &quot;~&gt; 3.0&quot; } ] end While cors_plug is not strictly required, you will very likely want it to be able to add to your endpoint so that clients cannot connect to your channel.","ref":"readme.html#installation"},{"type":"extras","title":"LiveState - Usage","doc":"First you need to set up a socket as you would with other normal Phoenix Channels On your Endpoint module, set up a socket for your channel: defmodule MyAppWeb.Endpoint do socket &quot;/socket&quot; , PgLiveHeroWeb.Channels.LiveStateSocket ... Then create the socket module with the topic to listen to: defmodule MyAppWeb.Socket do use Phoenix.Socket channel &quot;topic&quot; , MyAppWeb.Channel @impl true def connect ( _params , socket ) , do : { :ok , socket } @impl true def id ( _ ) , do : &quot;random_id&quot; end Create your channel using the LiveState.Channel behaviour: defmodule MyAppWeb.Channel do use LiveState.Channel , web_module : MyAppWeb ... Then define your initial state using the LiveState.Channel.init/3 callback, which will be called after channel joins and is expected to return the initial state: def init ( _channel , _payload , _socket ) , do : { :ok , %{ foo : &quot;bar&quot; } } State must be a map. It will be sent down as JSON, so anything in it must have a Jason.Encoder implementation.","ref":"readme.html#usage"},{"type":"extras","title":"LiveState - Events","doc":"For events emitted from the client, you implement the LiveState.Channel.handle_event/3 callback. If you need access the socket in your event handler, you may implement LiveState.Channel.handle_event/4 . def handle_event ( &quot;add_todo&quot; , todo , %{ todos : todos } ) do { :noreply , %{ todos : [ todo | todos ] } } end LiveState.Channel.handle_event/3 receives the following arguments event name payload current And returns a tuple whose last element is the new state. It can also return one or many events to dispatch on the calling DOM Element: def handle_event ( &quot;add_todo_with_one_reply&quot; , todo , %{ todos : todos } ) do { :reply , % Event { name : &quot;reply_event&quot; , detail : %{ foo : &quot;bar&quot; } } , %{ todos : [ todo | todos ] } } end def handle_event ( &quot;add_todo_with_two_replies&quot; , todo , %{ todos : todos } ) do { :reply , [ % Event { name : &quot;reply_event1&quot; , detail : %{ foo : &quot;bar&quot; } } , % Event { name : &quot;reply_event2&quot; , detail : %{ bing : &quot;baz&quot; } } ] , %{ todos : [ todo | todos ] } } end","ref":"readme.html#events"},{"type":"extras","title":"LiveState - Documentation","doc":"Tutorial - A step by step guide to building an embedded app using LiveState API Docs are available in the hex package .","ref":"readme.html#documentation"},{"type":"extras","title":"LiveState - Related projects","doc":"","ref":"readme.html#related-projects"},{"type":"extras","title":"LiveState - phx-live-state","doc":"The front end library npm package that implements sending and receiving events, and subscribing to state changes. It also facilitates building Custom Elements that are backed by LiveState.","ref":"readme.html#phx-live-state"},{"type":"extras","title":"LiveState - live-templates","doc":"Live-templates is an npm package that allows you to connect a front end template to a LiveState channel. Because it doesn't require a custom element or any other javascript code, it is probably the easiest way to get started with LiveState.","ref":"readme.html#live-templates"},{"type":"extras","title":"LiveState - use-live-state","doc":"A react hook for LiveState.","ref":"readme.html#use-live-state"},{"type":"extras","title":"LiveState - live_state_testbed","doc":"This is a Phoenix project that mainly provides integration tests for LiveState. It's also a great place to see examples of how to use LiveState.","ref":"readme.html#live_state_testbed"},{"type":"extras","title":"LiveState - Other resources","doc":"There are several examples of full LiveState projects. This blog post covers building an embeddable custom element for a comments section. The relevant source code repos are: https://github.com/launchscout/live_state_comments https://github.com/launchscout/livestate-comments This talk from ElixirConf 2022 also covers LiveState in detail. The code examples from the talk are in the repos below: https://github.com/launchscout/discord_element https://github.com/launchscout/discord-element","ref":"readme.html#other-resources"},{"type":"extras","title":"LiveState Tutorial","doc":"In this tutorial, we'll be building an embedded app with LiveState. In our example, we'll pretend we are working for a SAAS CRM product company: PipeSpot. Our team is tasked with building a new contact form that can be added to the websites of PipeSpot users.","ref":"tutorial_start.html"},{"type":"extras","title":"LiveState Tutorial - What's an embedded app?","doc":"I'm so glad you asked! An embedded app is designed to live inside a larger app. For our purposes the larger app is a customers website, and the embedded app is the PipeSpot contact form. How will this work? In this tutorial, we'll be creating custom element called &lt;contact-form&gt; that we'll be able to place on any PipeSpot customer website. It will be responsible for sending the contact's information to pipespot, and display a success message to the user upon completion. LiveState will allow us to keep our code surprisingly simple. Rather than needing a complicated front end framework, our front end code will only need to do two things: Render state Dispatch events","ref":"tutorial_start.html#what-s-an-embedded-app"},{"type":"extras","title":"LiveState Tutorial - Let's get started!","doc":"LiveState is a library that you add to a phoenix application, so to start we'll want to create a brand new phoenix app. You'll need to follow the instructions to instal phoenix on your system. Once you've done that, you can run: mix phx . new pipe_spot This will take just a minute to fetch the dependencies and compile. It will also give you some instructions for creating a database. You should do what it says :) Add live_state dependency After creating our app, we'll want to add the live_state package as a dependency. Add an entry for it in the deps function of mix.exs: def deps do [ ... { :live_state , &quot;~&gt; 0.7&quot; } , { :cors_plug , &quot;&gt;= 0.0.0&quot; } ] end In order to serve the javascript for the custom element we'll be building from the phoenix app, we'll also need to add CORSPlug to our endpoint. Just add a line to endpoint.ex : defmodule PipeSpotWeb.Endpoint do use Phoenix.Endpoint , otp_app : :pipe_spot plug CORSPlug ...","ref":"tutorial_start.html#let-s-get-started"},{"type":"extras","title":"LiveState Tutorial - Generating our Contacts context","doc":"The next step is to create the Contacts schema and context so our contacts will have a place to live in the database. For now, we'll keep things super simple and say a contact has a name, email, and phone number. We can use the phoenix generators to help us: mix phx . gen . context Contacts Contact contacts name :string email :string phone_number :string This will create the basics CRUD functions we need to work with Contacts. Don't forget to run mix ecto.migrate to create the database table.","ref":"tutorial_start.html#generating-our-contacts-context"},{"type":"extras","title":"LiveState Tutorial - Creating our &lt;contact-form&gt;","doc":"To create our &lt;contact-form&gt; custom element, we'll use a generator to help us out: mix live_state . gen . element ContactForm contact - form This will generate an element for us in app/js/contact-form.ts . While LiveState itself is not tied to any specific library, for the purposes of convenience we generate an element based on the lit library. The generator will also install the necessary npms for you. We'll also want to add an import for our element in app/js/custom_elements.js . You'll want to create this file if it doesn't exit. Add this line for the import: import './contact-form.js' Note: It is recommended your esbuild config to target es2020 : # Configure esbuild (the version is required) config :esbuild , version : &quot;0.17.11&quot; , default : [ args : ~w(js/app.js --bundle --target=es2020 --outdir=../priv/static/assets --external:/fonts/* --external:/images/*) , cd : Path . expand ( &quot;../assets&quot; , __DIR__ ) , env : %{ &quot;NODE_PATH&quot; =&gt; Path . expand ( &quot;../deps&quot; , __DIR__ ) } ] Render state, dispatch events As we mentioned earlier, the goal of LiveState is to keep our front end code simple. For our ContactForm element, our state is very simple indeed. To start with, we'll have a single property, complete , which will determine if we need to display the contact form or the success message. First, we'll add a complete field to hold this state, and tell LiveState we want it to be the source of this property. Here's the code we need to add the body of our element class: @state() @liveStateProperty() complete: Boolean = false; The redundant looking decorators are necessary because the @state decorator tells lit that this property should trigger re-renders on change. The @liveStateProperty() decorator tells LiveState to manage this property for us. LiveState is deliberately decoupled from Lit: we can use any library (or none at all!) with LiveState. Next, we need to implement our render method: render() { if (this.complete) { return html`&lt;div&gt;Thank you for being a friend :)&lt;/div&gt;` } else { return html` &lt;div&gt;Please to give us your precious data&lt;/div&gt; &lt;form @submit=${this.submitForm}&gt; &lt;div&gt; &lt;label&gt;Name&lt;/label&gt; &lt;input name=&quot;name&quot; required /&gt; &lt;/div&gt; &lt;div&gt; &lt;label&gt;Email&lt;/label&gt; &lt;input name=&quot;email&quot; type=&quot;email&quot; required /&gt; &lt;/div&gt; &lt;div&gt; &lt;label&gt;Phone Number&lt;/label&gt; &lt;input name=&quot;phone_number&quot; required /&gt; &lt;/div&gt; &lt;button&gt;Save&lt;/button&gt; &lt;/form&gt; `; } } For the form to work, we also need to to implement the submitForm method. We'll want to grab the form data and dispatch a 'create-contact' CustomEvent which we'll tell LiveState we want to send. Here's what the submitForm method looks like: submitForm(e: SubmitEvent) { e.preventDefault(); const form = e.target as HTMLFormElement; const formData = new FormData(form); const data = Object.fromEntries(formData.entries()); this.dispatchEvent(new CustomEvent('create-contact', { detail: data })); } And finally we'll need to add this new custom event to our @liveState decorator config: @liveState({ events: { send: ['create-contact'] } topic: 'contact_form:all' })","ref":"tutorial_start.html#creating-our-contact-form"},{"type":"extras","title":"LiveState Tutorial - Creating our Channel","doc":"The backend of a LiveState application is a Phoenix Channel that implements the LiveState.Channel behaviour. Our channel is responsible for managing the state of our application and providing it to our front end: in this case, our &lt;contact-form&gt; custom element. It receives events from the front end. Events may result in a new state, and any state changes are pushed to the front end over the channel. This keeps our front end code nice and simple, because it only needs to render the current state and dispatch events. To create the channel, we can use the live_state channel generator like so: mix live_state . gen . channel ContactForm When it asks, we can let it go ahead and create the socket for us and add the channel to it. We'll need to add this new socket to our endpoint: socket &quot;/live_state&quot; , PipeSpotWeb.LiveStateSocket","ref":"tutorial_start.html#creating-our-channel"},{"type":"extras","title":"LiveState Tutorial - Creating contacts","doc":"To implement our channel, we need to add callbacks to build the intial state and handle our create-contact event that is dispatched from the &lt;contact-form&gt; element. The initial state is returned in the init callback like so: @impl true def init ( _channel , _params , _socket ) do { :ok , %{ complete : false } } end To create our contact, we'll use the context module we generated earlier and call it in the handle_event callback. The payload from the create-contact event will have exactly what we need to give to Contacts.create_contact . Here's the code we need: @impl true def handle_event ( &quot;create-contact&quot; , contact_attrs , state ) do case Contacts . create_contact ( contact_attrs ) do { :ok , _contact } -&gt; { :noreply , Map . put ( state , :complete , true ) } { :error , _ } -&gt; { :noreply , state } end end","ref":"tutorial_start.html#creating-contacts"},{"type":"extras","title":"LiveState Tutorial - Taking our &lt;contact-form&gt; for a spin","doc":"At this point, we have everything in place to be able use our custom element on a page. To do so, you can write are the simplest possible html file that uses the element like so: &lt;html&gt; &lt;head&gt; &lt;script type=&quot;module&quot; src=&quot;http://localhost:4000/assets/custom_elements.js&quot;&gt;&lt;/script&gt; &lt;/head&gt; &lt;body&gt; &lt;contact-form url=&quot;ws://localhost:4000/live_state&quot;&gt;&lt;/contact-form&gt; &lt;/body&gt; &lt;/html&gt; To see it in action, make sure you start up the phoenix app with mix phx.server . We're presuming it's listening on the standard port (4000). You can then just open the html file in your browser. You don't even need a server at all. This proves the main advantage of an embedded app: you really can serve it from anywhere (or nowhere!). You should be able fill out the form, submit it, and see a helpful thank you message!","ref":"tutorial_start.html#taking-our-contact-form-for-a-spin"},{"type":"extras","title":"LiveState Tutorial - Next steps","doc":"There's a lot more we'd probably like to do. We currently don't have any error handling. We've marked all our fields as required so the browser will do some validation for us, but to make things better we we would need to parse errors from changeset and add them to the state on our custom element. We'll tackle that in a future installment. There's also some examples of things we didn't get a chance to cover yet in the live_state_testbed project, including: Error handling Channel join params Listening to livestate-change events","ref":"tutorial_start.html#next-steps"},{"type":"extras","title":"LiveState Tutorial - I just wanna see the answer...","doc":"The completed code for this tutorial is here .","ref":"tutorial_start.html#i-just-wanna-see-the-answer"}]